UM .NET API 6.17.1

- Main Page
- Related Pages
- Packages
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
com.latencybusters.lbm.LBMSource Class Reference

LBM Source class. More...

Inheritance diagram for com.latencybusters.lbm.LBMSource:

## Public Member Functions
| LBMSource (LBMContext lbmctx, LBMTopic lbmtopic)
| Instantiate an LBM Source object associated with a given context and topic. More...
| LBMSource (LBMContext lbmctx, LBMTopic lbmtopic, LBMSourceEventCallback cb, object cbArg)
| Instantiate an LBM Source object associated with a given context and topic and initialize source event callback. More...
| LBMSource (LBMContext lbmctx, LBMTopic lbmtopic, LBMEventQueue lbmevq)
| Instantiate an LBM Source object associated with a given context, topic, and event queue. More...
| LBMSource (LBMContext lbmctx, LBMTopic lbmtopic, LBMSourceEventCallback cb, object cbArg, LBMEventQueue lbmevq)
| Instantiate an LBM Source object associated with a given context, topic, and event queue and initialize source event callback. More...
void | close ()
| Close and dispose of this source. More...
void | umederegister ()
| Deregister the UME Source. More...
bool | isClosed ()
| Check if a source has been closed. More...
LBMSourceChannelInfo | createChannel (long channelNumber)
| Create a channel object to send messages with the given channel number. More...
void | deleteChannel (LBMSourceChannelInfo channelInfo)
| Deletea channel object. More...
void | addSourceCallback (LBMSourceEventCallback cb)
| Register a source event callback. More...
void | addSourceCallback (LBMSourceEventCallback cb, object cbArg)
| Register a source event callback (and callback token) More...
void | removeSourceCallback (LBMSourceEventCallback cb)
| Deregister a source event callback. More...
void | removeSourceCallback (LBMSourceEventCallback cb, object cbArg)
| Deregister a source event callback. More...
unsafe List< LBMConfigOption > | dumpAttributeList ()
| Dump source configuration options. More...
string | getAttributeValue (string attributeName)
| Returns the value of a source-related attribute for this source. More...
void | setAttributeValue (string attributeName, string attributeValue)
| Set the value of a source-related attribute for this source. More...
LBMSourceStatistics | getStatistics ()
| Return the current set of source transport statistics for this source. More...
void | resetStatistics ()
| This will reset the transport statistics for this source. More...
int | getInflight (int type)
| Get the current inflight value for this source. More...
int | setInflight (int type, LBMSetInflightCallback cb, object cbObj)
| Set the current inflight value for this source. More...
void | getInflight (int type, out int messages, out ulong bytes)
| Get the current inflight values for message and bytes. More...
void | setInflight (int type, out int messages, out ulong bytes, LBMSetInflightCallbackEx cb, object cbObj)
| Set the current inflight messages and bytes for this source. Note that increasing one value while decreasing the other is not allowed. If you need to do this, call setInflight twice using 0 as the value for the one you are not changing. More...
void | setUMEMessageStable (long sqn)
| Mark a specific sqn as stable, triggering an event if configured to do so, and adjusting the inflight if necessary. More...
void | send (byte[] message, int messageLength, int flags)
| Send a message to the topic associated with the LBM source. More...
void | send (byte[] message, int messageLength, int flags, object cbArg)
| Send a message to the topic associated with the LBM source. More...
void | send (byte[] message, int messageLength, int flags, LBMSourceSendExInfo exinfo)
| Send a message to the topic associated with the LBM source. More...
void | send (LBMRequest lbmreq, int flags)
| Send a request message to the topic associated with the LBM source. More...
void | send (LBMRequest lbmreq, LBMEventQueue lbmevq, int flags)
| Send a request message to the topic associated with the LBM source using a designated event queue for responses. More...
void | send (LBMRequest lbmreq, int flags, LBMSourceSendExInfo exinfo)
| Send a request message to the topic associated with the LBM source using an designated event queue for responses. More...
void | send (LBMRequest lbmreq, LBMEventQueue lbmevq, int flags, LBMSourceSendExInfo exinfo)
| Send a request message to the topic associated with the LBM source using an designated event queue for responses. More...
void | flush ()
| Send messages from both the explicit and implicit batches ASAP. More...
int | buffAcquire (out IntPtr bufp, uint len, int flags)
| Acquire a pointer to a buffer of the specified length, to be filled in and sent later. Warning: this API is NOT thread safe between sources on the same transport session. For thread safety, use the send api. More...
void | buffsComplete ()
| Sends all buffers on a transport session that had ben previously acquired. Warning: this API is NOT thread safe between sources on the same transport session.
int | buffsCompleteAndAcquire (out IntPtr bufp, uint len, int flags)
| First sends all buffers on a transport session that had ben previously acquired, and then acquires a pointer to a buffer of the specified length, to be filled in and sent later. Warning: this API is NOT thread safe between sources on the same transport session. More...
void | buffsCancel ()
| Cancels all outstanding (not yet completed) buffers previously acquired using buffAcquire or buffsCompleteAndAcquire. All such acquired but not completed buffers for this source (only) will no longer be received by any receives.
void | Dispose ()
| Same as close. More...

## Detailed Description

LBM Source class.

Warning: It is not safe to instantiate this object from a context thread.

## Constructor & Destructor Documentation

com.latencybusters.lbm.LBMSource.LBMSource | ( | LBMContext | lbmctx,
|  | LBMTopic | lbmtopic
| ) |  |

Instantiate an LBM Source object associated with a given context and topic.

Warning: It is not safe to call this constructor from a context thread callback.

Parameters

  lbmctx | Context with which to associate the source
  lbmtopic | LBMTopic used to initialize the source

References com.latencybusters.lbm.LBMSourceEventCallback().

com.latencybusters.lbm.LBMSource.LBMSource | ( | LBMContext | lbmctx,
|  | LBMTopic | lbmtopic,
|  | LBMSourceEventCallback | cb,
|  | object | cbArg
| ) |  |

Instantiate an LBM Source object associated with a given context and topic and initialize source event callback.

Warning: It is not safe to call this constructor from a context thread callback.

Parameters

  lbmctx | Context with which to associate the source
  lbmtopic | LBMTopic used to initialize the source
  cb | Callback implementing the LBMSourceEventCallback delegate interface
  cbArg | Callback token object

com.latencybusters.lbm.LBMSource.LBMSource | ( | LBMContext | lbmctx,
|  | LBMTopic | lbmtopic,
|  | LBMEventQueue | lbmevq
| ) |  |

Instantiate an LBM Source object associated with a given context, topic, and event queue.

Warning: It is not safe to call this constructor from a context thread callback.

Parameters

  lbmctx | Context with which to associate the source
  lbmtopic | LBMTopic used to initialize the source
  lbmevq | Event queue with which to associate the source (all source events will be posted to this event queue)

References com.latencybusters.lbm.LBMSourceEventCallback().

com.latencybusters.lbm.LBMSource.LBMSource | ( | LBMContext | lbmctx,
|  | LBMTopic | lbmtopic,
|  | LBMSourceEventCallback | cb,
|  | object | cbArg,
|  | LBMEventQueue | lbmevq
| ) |  |

Instantiate an LBM Source object associated with a given context, topic, and event queue and initialize source event callback.

Warning: It is not safe to call this constructor from a context thread callback.

Parameters

  lbmctx | Context with which to associate the source
  lbmtopic | LBMTopic used to initialize the source
  cb | Callback implementing the LBMSourceEventCallback delegate interface
  cbArg | Callback token object
  lbmevq | Event queue with which to associate the source

Exceptions

  com.latencybusters.lbm.LBMEInvalException | Topic is not a source topic
  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.EINVAL, com.latencybusters.lbm.LBM.errorMessage(), com.latencybusters.lbm.LBM.errorNumber(), com.latencybusters.lbm.LBM.SRC_TOPIC_ATTR_UMQ_ULB_EVENT_MSG_COMPLETE, com.latencybusters.lbm.LBMTransportSourceInfo.TRANSPORT_TYPE_BROKER, and com.latencybusters.lbm.LBMTransportSourceInfo.TRANSPORT_TYPE_LBTSMX.

## Member Function Documentation

void com.latencybusters.lbm.LBMSource.addSourceCallback | ( | LBMSourceEventCallback | cb | ) |

Register a source event callback.

See also
  LBMSourceEventCallback
  removeSourceCallback

Parameters

  cb | Callback implementing the LBMSourceEventCallback delegate interface

void com.latencybusters.lbm.LBMSource.addSourceCallback | ( | LBMSourceEventCallback | cb,
|  | object | cbArg
| ) |  |

Register a source event callback (and callback token)

See also
  LBMSourceEventCallback
  removeSourceCallback

Parameters

  cb | Callback implementing the LBMSourceEventCallback delegate interface
  cbArg | Callback token object

int com.latencybusters.lbm.LBMSource.buffAcquire | ( | out IntPtr | bufp,
|  | uint | len,
|  | int | flags
| ) |  |

Acquire a pointer to a buffer of the specified length, to be filled in and sent later. Warning: this API is NOT thread safe between sources on the same transport session. For thread safety, use the send api.

Parameters

  bufp | A pointer to the location in memory availble for writing to.
  len | The request length of the buffer in bytes
  flags | Set to LBM.SRC_NONBLOCK for non-blocking behavior. Default is blocking.

Returns
  0 if successful, -1 if send would block and non-blocking sends were requested.

References com.latencybusters.lbm.LBM.EINVAL.

int com.latencybusters.lbm.LBMSource.buffsCompleteAndAcquire | ( | out IntPtr | bufp,
|  | uint | len,
|  | int | flags
| ) |  |

First sends all buffers on a transport session that had ben previously acquired, and then acquires a pointer to a buffer of the specified length, to be filled in and sent later. Warning: this API is NOT thread safe between sources on the same transport session.

Parameters

  bufp | A pointer to the location in memory availble for writing to.
  len | The request length of the buffer in bytes
  flags | Set to LBM.SRC_NONBLOCK for non-blocking behavior. Default is blocking.

Returns
  0 if successful, -1 if send would block and non-blocking sends were requested.

References com.latencybusters.lbm.LBM.EINVAL, com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

void com.latencybusters.lbm.LBMSource.close | ( |  | ) |

Close and dispose of this source.

Warning: It is not safe to call this method from a context thread callback.

LBMSourceChannelInfo com.latencybusters.lbm.LBMSource.createChannel | ( | long | channelNumber | ) |

Create a channel object to send messages with the given channel number.

Parameters

  channelNumber | Channel number in the range 0-4294967295

Returns
  A new LBMSourceChannelInfo object

void com.latencybusters.lbm.LBMSource.deleteChannel | ( | LBMSourceChannelInfo | channelInfo | ) |

Deletea channel object.

Parameters

  channelInfo | A channelInfo object

References com.latencybusters.lbm.LBMSourceChannelInfo.close().

void com.latencybusters.lbm.LBMSource.Dispose | ( |  | ) |

Same as close.

See also
  close

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

unsafe List<LBMConfigOption> com.latencybusters.lbm.LBMSource.dumpAttributeList | ( |  | ) |

Dump source configuration options.

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

Returns
  An array of LBMConfigOptions

References com.latencybusters.lbm.LBM.errorMessage(), com.latencybusters.lbm.LBM.errorNumber(), com.latencybusters.lbm.LBMConfigOption.OptionName, com.latencybusters.lbm.LBMConfigOption.Type, and com.latencybusters.lbm.LBMConfigOption.Value.

void com.latencybusters.lbm.LBMSource.flush | ( |  | ) |

Send messages from both the explicit and implicit batches ASAP.

Note
  calling lbm_src_flush() for a given source effectively flushes the implicit batcher for all sources on the same transport session.

Warning
  Do not call this function from a context thread callback. It can result in deadlock.

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

string com.latencybusters.lbm.LBMSource.getAttributeValue | ( | string | attributeName | ) |

Returns the value of a source-related attribute for this source.

Parameters

  attributeName | Name of the attribute to retrieve

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

Returns
  Value corresponding to the specified attribute name

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

int com.latencybusters.lbm.LBMSource.getInflight | ( | int | type | ) |

Get the current inflight value for this source.

Parameters

  type | The type of flight size

Exceptions

  com.latencybusters.lbm.LBMException | if an error occurs while retrieving the inflight value

Returns
  the inflight value

void com.latencybusters.lbm.LBMSource.getInflight | ( | int | type,
|  | out int | messages,
|  | out ulong | bytes
| ) |  |

Get the current inflight values for message and bytes.

Parameters

  type | The type of flight size
  messages | This reference will be set to the current number of inflight messages.
  bytes | This reference will be set to the current number of inflight bytes.

LBMSourceStatistics com.latencybusters.lbm.LBMSource.getStatistics | ( |  | ) |

Return the current set of source transport statistics for this source.

Returns
  LBMSourceStatistics object containing the statistics corresponding to this source

References com.latencybusters.lbm.LBMSourceStatistics.refresh(), and com.latencybusters.lbm.LBMObjectRecyclerBase.retrieveSourceStatistics().

bool com.latencybusters.lbm.LBMSource.isClosed | ( |  | ) |

Check if a source has been closed.

Returns
  A bool that is true if the source no longer points to a valid C reference

void com.latencybusters.lbm.LBMSource.removeSourceCallback | ( | LBMSourceEventCallback | cb | ) |

Deregister a source event callback.

See also
  LBMSourceEventCallback
  addSourceCallback

Parameters

  cb | Previously registered callback implementing the LBMSourceEventCallback delegate interface

void com.latencybusters.lbm.LBMSource.removeSourceCallback | ( | LBMSourceEventCallback | cb,
|  | object | cbArg
| ) |  |

Deregister a source event callback.

See also
  LBMSourceEventCallback
  addSourceCallback

Parameters

  cb | Previously registered callback implementing the LBMSourceEventCallback delegate interface
  cbArg | Callback token object

References com.latencybusters.lbm.LBMSourceEventCallback(), and com.latencybusters.lbm.LBMObjectRecyclerBase.retrieveSourceEvent().

void com.latencybusters.lbm.LBMSource.resetStatistics | ( |  | ) |

This will reset the transport statistics for this source.

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

void com.latencybusters.lbm.LBMSource.send | ( | byte[] | message,
|  | int | messageLength,
|  | int | flags
| ) |  |

Send a message to the topic associated with the LBM source.

Note
  If called from a context thread callback, use the LBM_SRC_NONBLOCK flag and handle any LBM_EWOULDBLOCK errors internally.

Warning
  Do not call this function from a context thread callback for persistence stability or persistence confirmation events. It can result in deadlock.

Possible OR'd set of flag value include:

LBM.SRC_NONBLOCK, LBM.SRC_BLOCK, LBM.MSG_START_BATCH, LBM.MSG_END_BATCH, LBM.MSG_COMPLETE_BATCH, and LBM.MSG_FLUSH LBM.SRC_EVENT_UME_MESSAGE_STABLE LBM.SRC_EVENT_UME_DELIVERY_CONFIRMATION

Parameters

  message | Data to send in this message
  messageLength | Number of bytes of data to send in this message
  flags | Flags indicating various conditions

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.errorMessage(), com.latencybusters.lbm.LBM.errorNumber(), com.latencybusters.lbm.LBM.EWOULDBLOCK, and com.latencybusters.lbm.LBM.SRC_NONBLOCK.

void com.latencybusters.lbm.LBMSource.send | ( | byte[] | message,
|  | int | messageLength,
|  | int | flags,
|  | object | cbArg
| ) |  |

Send a message to the topic associated with the LBM source.

Note
  If called from a context thread callback, use the LBM_SRC_NONBLOCK flag and handle any LBM_EWOULDBLOCK errors internally.

Warning
  Do not call this function from a context thread callback for persistence stability or persistence confirmation events. It can result in deadlock.

Possible OR'd set of flag value include:

LBM.SRC_NONBLOCK, LBM.SRC_BLOCK, LBM.MSG_START_BATCH, LBM.MSG_END_BATCH, LBM.MSG_COMPLETE_BATCH, and LBM.MSG_FLUSH LBM.SRC_EVENT_UME_MESSAGE_STABLE LBM.SRC_EVENT_UME_DELIVERY_CONFIRMATION

Parameters

  message | Data to send in this message
  messageLength | Number of bytes of data to send in this message
  flags | Flags indicating various conditions
  cbArg | Client object to be passed back in stability or confirmation events related to this message (UME only)

Exceptions

  com.latencybusters.lbm.LBMEInvalException | Certified delivery notification is not enabled
  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.EINVAL, com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

void com.latencybusters.lbm.LBMSource.send | ( | byte[] | message,
|  | int | messageLength,
|  | int | flags,
|  | LBMSourceSendExInfo | exinfo
| ) |  |

Send a message to the topic associated with the LBM source.

Note
  If called from a context thread callback, use the LBM_SRC_NONBLOCK flag and handle any LBM_EWOULDBLOCK errors internally.

Warning
  Do not call this function from a context thread callback for persistence stability or persistence confirmation events. It can result in deadlock.

Possible OR'd set of flag value include:

LBM.SRC_NONBLOCK, LBM.SRC_BLOCK, LBM.MSG_START_BATCH, LBM.MSG_END_BATCH, LBM.MSG_COMPLETE_BATCH, and LBM.MSG_FLUSH LBM.SRC_EVENT_UME_MESSAGE_STABLE LBM.SRC_EVENT_UME_MESSAGE_STABLE_EX LBM.SRC_EVENT_UME_DELIVERY_CONFIRMATION LBM.SRC_EVENT_UME_DELIVERY_CONFIRMATION_EX

Parameters

  message | Data to send in this message
  messageLength | Number of bytes of data to send in this message
  flags | Flags indicating various conditions
  exinfo | LBMSourceSendExInfo object, which includes flags to change callback behavior and a client-supplied object to be passed back. (UME only)

Exceptions

  com.latencybusters.lbm.LBMEInvalException | Confirmed delivery or message stability notifications are not enabled
  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBMSourceSendExInfo.channelInfo(), com.latencybusters.lbm.LBMSourceSendExInfo.clientObject(), com.latencybusters.lbm.LBM.EINVAL, com.latencybusters.lbm.LBM.errorMessage(), com.latencybusters.lbm.LBM.errorNumber(), com.latencybusters.lbm.UMQIndexInfo.flags(), com.latencybusters.lbm.LBMSourceSendExInfo.flags(), com.latencybusters.lbm.UMQIndexInfo.index(), com.latencybusters.lbm.UMQIndexInfo.indexLength(), com.latencybusters.lbm.UMQIndexInfo.numericIndex(), com.latencybusters.lbm.LBMSourceSendExInfo.properties(), com.latencybusters.lbm.UMQMessageTotalLifetimeInfo.totalLifetime(), and com.latencybusters.lbm.LBM.UMQ_INDEX_FLAG_NUMERIC.

void com.latencybusters.lbm.LBMSource.send | ( | LBMRequest | lbmreq,
|  | int | flags
| ) |  |

Send a request message to the topic associated with the LBM source.

Note
  If called from a context thread callback, use the LBM_SRC_NONBLOCK flag and handle any LBM_EWOULDBLOCK errors internally.

Warning
  Do not call this function from a context thread callback for persistence stability or persistence confirmation events. It can result in deadlock.

Possible OR'd set of flag value include:

LBM.SRC_NONBLOCK, LBM.SRC_BLOCK, LBM.MSG_START_BATCH, LBM.MSG_END_BATCH, LBM.MSG_COMPLETE_BATCH, and LBM.MSG_FLUSH

Parameters

  lbmreq | LBMRequest object
  flags | Flags indicating various conditions

void com.latencybusters.lbm.LBMSource.send | ( | LBMRequest | lbmreq,
|  | LBMEventQueue | lbmevq,
|  | int | flags
| ) |  |

Send a request message to the topic associated with the LBM source using a designated event queue for responses.

Note
  If called from a context thread callback, use the LBM_SRC_NONBLOCK flag and handle any LBM_EWOULDBLOCK errors internally.

Warning
  Do not call this function from a context thread callback for persistence stability or persistence confirmation events. It can result in deadlock.

Possible OR'd set of flag value include:

LBM.SRC_NONBLOCK, LBM.SRC_BLOCK, LBM.MSG_START_BATCH, LBM.MSG_END_BATCH, LBM.MSG_COMPLETE_BATCH, and LBM.MSG_FLUSH

Parameters

  lbmreq | LBMRequest object
  lbmevq | LBMEventQueue used to handle response messages
  flags | Flags indicating various conditions

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBMRequest.data(), com.latencybusters.lbm.LBMRequest.dataLength(), com.latencybusters.lbm.LBM.EINVAL, com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

void com.latencybusters.lbm.LBMSource.send | ( | LBMRequest | lbmreq,
|  | int | flags,
|  | LBMSourceSendExInfo | exinfo
| ) |  |

Send a request message to the topic associated with the LBM source using an designated event queue for responses.

Note
  If called from a context thread callback, use the LBM_SRC_NONBLOCK flag and handle any LBM_EWOULDBLOCK errors internally.

Warning
  Do not call this function from a context thread callback for persistence stability or persistence confirmation events. It can result in deadlock.

Possible OR'd set of flag value include:

LBM.SRC_NONBLOCK, LBM.SRC_BLOCK, LBM.MSG_START_BATCH, LBM.MSG_END_BATCH, LBM.MSG_COMPLETE_BATCH, and LBM.MSG_FLUSH

Parameters

  lbmreq | LBMRequest object
  flags | Flags indicating various conditions
  exinfo | LBMSourceSendExInfo object, which includes flags to change callback behavior and a client-supplied object to be passed back. (UME only)

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

void com.latencybusters.lbm.LBMSource.send | ( | LBMRequest | lbmreq,
|  | LBMEventQueue | lbmevq,
|  | int | flags,
|  | LBMSourceSendExInfo | exinfo
| ) |  |

Send a request message to the topic associated with the LBM source using an designated event queue for responses.

Note
  If called from a context thread callback, use the LBM_SRC_NONBLOCK flag and handle any LBM_EWOULDBLOCK errors internally.

Warning
  Do not call this function from a context thread callback for persistence stability or persistence confirmation events. It can result in deadlock.

Possible OR'd set of flag value include:

LBM.SRC_NONBLOCK, LBM.SRC_BLOCK, LBM.MSG_START_BATCH, LBM.MSG_END_BATCH, LBM.MSG_COMPLETE_BATCH, and LBM.MSG_FLUSH

Parameters

  lbmreq | LBMRequest object
  lbmevq | LBMEventQueue used to handle response messages
  flags | Flags indicating various conditions
  exinfo | LBMSourceSendExInfo object, which includes flags to change callback behavior and a client-supplied object to be passed back. (UME only)

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBMSourceSendExInfo.channelInfo(), com.latencybusters.lbm.LBMSourceSendExInfo.clientObject(), com.latencybusters.lbm.LBMRequest.data(), com.latencybusters.lbm.LBMRequest.dataLength(), com.latencybusters.lbm.LBM.EINVAL, com.latencybusters.lbm.LBM.errorMessage(), com.latencybusters.lbm.LBM.errorNumber(), com.latencybusters.lbm.UMQIndexInfo.flags(), com.latencybusters.lbm.LBMSourceSendExInfo.flags(), com.latencybusters.lbm.UMQIndexInfo.index(), com.latencybusters.lbm.UMQIndexInfo.indexLength(), com.latencybusters.lbm.UMQIndexInfo.numericIndex(), com.latencybusters.lbm.UMQMessageTotalLifetimeInfo.totalLifetime(), and com.latencybusters.lbm.LBM.UMQ_INDEX_FLAG_NUMERIC.

void com.latencybusters.lbm.LBMSource.setAttributeValue | ( | string | attributeName,
|  | string | attributeValue
| ) |  |

Set the value of a source-related attribute for this source.

Parameters

  attributeName | Name of the attribute to set
  attributeValue | New attribute value

Exceptions

  com.latencybusters.lbm.LBMException | Invalid argument or unexpected operational behavior has been encountered by unmanaged LBM C layer function.

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

int com.latencybusters.lbm.LBMSource.setInflight | ( | int | type,
|  | LBMSetInflightCallback | cb,
|  | object | cbObj
| ) |  |

Set the current inflight value for this source.

Parameters

  type | The type of flight size
  cb | LBMSetInflightCallback delegate
  cbObj | Client object passed into callback

Exceptions

  com.latencybusters.lbm.LBMException | if an error occurs while setting the inflight value

Returns
  the new inflight value

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

void com.latencybusters.lbm.LBMSource.setInflight | ( | int | type,
|  | out int | messages,
|  | out ulong | bytes,
|  | LBMSetInflightCallbackEx | cb,
|  | object | cbObj
| ) |  |

Set the current inflight messages and bytes for this source. Note that increasing one value while decreasing the other is not allowed. If you need to do this, call setInflight twice using 0 as the value for the one you are not changing.

Parameters

  type | The type of flight size
  messages | This reference will be set to the new number of inflight messages
  bytes | This reference will be set to the new number of inflight bytes
  cb | Delegate called when appropriate locking is held to let the application safely set set values
  cbObj | Client object passed into the callback

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

void com.latencybusters.lbm.LBMSource.setUMEMessageStable | ( | long | sqn | ) |

Mark a specific sqn as stable, triggering an event if configured to do so, and adjusting the inflight if necessary.

Parameters

  sqn | Sqn of the fragment to mark stable

Exceptions

  com.latencybusters.lbm.LBMException | if an error occurs while marking the fragment stable

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

void com.latencybusters.lbm.LBMSource.umederegister | ( |  | ) |

Deregister the UME Source.

Returns
  Void

References com.latencybusters.lbm.LBM.errorMessage(), and com.latencybusters.lbm.LBM.errorNumber().

The documentation for this class was generated from the following file:

- LBMSource.cs